stages:
  - build
  - review
  - deploy

include:
  - template: 'Workflows/MergeRequest-Pipelines.gitlab-ci.yml'

.base_build:
  stage: build
  image: ruby:latest
  before_script:
    - bundle install
  script:
    - "bundle exec jekyll build \
        -d public$SUBPATH \
        --baseurl $SUBPATH"
  artifacts:
    paths:
      - public
  cache:
    paths:
      - vendor/bundle

  interruptible: true

build:
  extends: .base_build
  variables:
    SUBPATH: /

build:reviewapps:
  extends: .base_build
  variables:
    SUBPATH: /review-apps/$CI_PROJECT_PATH_SLUG/$CI_COMMIT_REF_SLUG/

review:
  stage: review
  variables:
    GIT_STRATEGY: none
    REVIEW_APPS_PATH: review-apps/$CI_PROJECT_PATH_SLUG/$CI_COMMIT_REF_SLUG/
  needs: ["build:reviewapps"]
  dependencies: ["build:reviewapps"]
  script:
    - mkdir -p /var/www/html/gl-review-apps/$REVIEW_APPS_PATH
    - rsync -a --delete ./public/$REVIEW_APPS_PATH/. /var/www/html/gl-review-apps/$REVIEW_APPS_PATH/.
  environment:
    name: review/$CI_COMMIT_REF_NAME
    url: https://$APPS_DOMAIN/review-apps/$CI_PROJECT_PATH_SLUG/$CI_COMMIT_REF_SLUG/
    on_stop: stop_review
  tags:
    - review-apps

stop_review:
  stage: review
  variables:
    GIT_STRATEGY: none
    REVIEW_APPS_PATH: review-apps/$CI_PROJECT_PATH_SLUG/$CI_COMMIT_REF_SLUG/
  script:
    - rm -rf public /var/www/html/gl-review-apps/$REVIEW_APPS_PATH
    - rmdir --ignore-fail-on-non-empty /var/www/html/gl-review-apps/review-apps/$CI_PROJECT_PATH_SLUG/
  dependencies: []
  when: manual
  environment:
    name: review/$CI_COMMIT_REF_NAME
    action: stop
  tags:
    - review-apps

pages:
  image: alpine:latest
  stage: deploy
  variables:
    GIT_STRATEGY: none
  needs: ["build"]
  dependencies: ["build"]
  script:
    - echo "Skip script section"
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'
  artifacts:
    paths:
      - public
